<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class  AlertaDesalocacaoRecursoAgendadoFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Busca no banco de dados os dados para o envio do alerta de desalocação do recurso;
    **/
    public function getDadosDesalocacao(array $params){
        $sql = "SELECT DSEMAILSDESALCREC, 
                    QTDIASDESALOCREC
                FROM FCT_PARAMETROGERAL
                WHERE NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    /**
     * Busca no banco de dados os agendamentos de recursos que serão desalocados
    **/
    public function getAgendamentosParaDesalocacao(array $params){
        $sql = "SELECT COUNT(*) AS QTAGENDAMENTOS
                FROM FCT_AGENDRECURSOCONT AGEND
                INNER JOIN FCT_CONTRATO CONT
                    ON CONT.NRSEQCONTRATO = AGEND.NRSEQCONTRATO
                    AND CONT.NRORG        = AGEND.NRORG
                INNER JOIN PARCNEGOCIO PARC
                    ON PARC.NRPARCNEGOCIO = CONT.NRPARCNEGOCIO
                    AND PARC.NRORG        = CONT.NRORG
                LEFT JOIN FCT_RECURSOSAGENDCONT RECAG    
                    ON RECAG.NRAGENDRECURSOCONT = AGEND.NRAGENDRECURSOCONT
                    AND RECAG.NRORG             = AGEND.NRORG
                LEFT JOIN FCT_ITEMCONTRATO ITEM
                    ON ITEM.NRITEMOCONTRATO = RECAG.NRITEMOCONTRATO
                    AND ITEM.NRORG          = RECAG.NRORG 
                LEFT JOIN FCT_VIEW_RECURSOS_DISP VIEWREC
                    ON  NVL(TO_CHAR(RECAG.NRPARCNEPESSOA), NVL(RECAG.CDBEMATIVO, RECAG.CDPRODUTO)) = VIEWREC.CHAVE
                WHERE AGEND.NRORG = :NRORG
                    AND TRUNC(AGEND.DTFIMAGENDAMENTO - :QTDIASDESALOCREC) = TRUNC(SYSDATE)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}