/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NATUCONT                                                 */
/* Tabela : NATUCONT                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2007 - Rejane P. Leite                                               */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE TRIGGER DTULTATU_NATUCONT
BEFORE INSERT OR UPDATE OR DELETE
ON NATUCONT FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNACO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDNATUCONT,0 )   <> NVL(:NEW.CDNATUCONT,0))   OR
         (NVL(:OLD.NMNATUCONT,0 )   <> NVL(:NEW.NMNATUCONT,0)) THEN
         :NEW.DTULTATUNACO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NATUCONT', '','CDNATUCONT='||:OLD.CDNATUCONT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NATUCONT MODIFY DTULTATUNACO DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_NATUCONT','5.03.010'); END;
/

